/*!
* @file FixedArtifact.h
* @brief ゲーム中の固定アーティファクトのプロトタイプ
* @date 2013/12/17
* @author Deskull
* 2013 Sikabane Works.
*/

#include "stdafx.h"
#include "Dice.h"
#include "GameElement.h"
#include "ItemTemplate.h"
#include "SavingTable.h"

BOOST_CLASS_VERSION(FixedArtifact, 1);

namespace Deeangband
{

	/*!
	* @class FixedArtifact
	* @brief 固定アーティファクトのクラス
	*/
	class FixedArtifact : public ItemTemplate
	{
	private:
		std::string name; //!< ベースアイテムの名前
		Dice baseDamage; //!< ベースダメージのダイス
		WEIGHT weight; //!< アイテムの重量
		SavingTable baseSaving; //!< 基本セービング修正
		SavingTable plusSaving; //!< 追加セービング修正

		friend class boost::serialization::access;

		/*!
		* @brief クラスのシリアライズ化を設定する
		* @param archive アーカイブ化するクラスのアドレス
		* @param fileVersion ファイルバージョン
		* @return XMLSerializeテンプレート
		*/
		template<class Archive> void serialize(Archive &archive, const unsigned int fileVersion) 
		{
			archive & BOOST_SERIALIZATION_NVP(name);
			archive & BOOST_SERIALIZATION_NVP(baseDamage);
			archive & BOOST_SERIALIZATION_NVP(weight);
			archive & BOOST_SERIALIZATION_NVP(baseSaving);
			archive & BOOST_SERIALIZATION_NVP(plusSaving);
		}

	public:

		/*! 
		* @brief FixedArtifactクラスコンストラクタ(GameElementメンバ対応)
		* @param id GameElementのID
		* @param tag GameElementのタグ
		* @param gameWorld 所属元gameWorld参照ポインタ
		*/
		FixedArtifact::FixedArtifact(ID id, TAG tag, GameWorld *gameWorld);

		/*! 
		* @brief FixedArtifactクラスコンストラクタ
		*/
		FixedArtifact::FixedArtifact(void);

		/*! 
		* @brief FixedArtifactクラスデストラクタ
		*/
		FixedArtifact::~FixedArtifact(void);

		/*! 
		* @brief ダミーデータによる初期化
		* @return なし
		*/
		void FixedArtifact::SetDammyData(void);

	};

}